﻿//Original Author: Paul Hunt - January 2015

//Create our Namespace object to avoid polluting the global namespace
var pfh = pfh || {};

pfh.actionMatrix = {};
pfh.ModalActionItem = null;


pfh.SetupBehaviours = function () {
	//jQuery('.formManagerItemWrapper').mouseenter(pfh.HoverEnterBehaviour).mouseleave(pfh.HoverExitBehaviour);
	jQuery('.formManagerItemWrapper').mouseenter(pfh.HoverEnterBehaviour).mouseleave(pfh.HoverExitBehaviour);

}

//Currently animates the entire square!
pfh.HoverEnterBehaviour = function(obj) {
	jQuery("#" + obj.currentTarget.id + " .formManagerItemTextDetail").css('overflow','visible');
	jQuery("#" + obj.currentTarget.id + " .formManagerItemTextWrapper").animate({top: "-=100"},500);
}

pfh.HoverExitBehaviour = function(obj) {
	jQuery("#" + obj.currentTarget.id + " .formManagerItemTextWrapper").animate({top: "+=100"},500);
	jQuery("#" + obj.currentTarget.id + " .formManagerItemTextDetail").css('overflow','hidden');
}


//Define our Header Render pattern
pfh.renderHeader = function(ctx) {
	//Define any header content here.
	//You can include JavaScript and CSS links here.
	pfh.CheckForJQuery();
	var headerHTML = "<link rel='stylesheet' type='text/css' href='../../_catalogs/masterpage/display templates/csr_ovr_RenderFormManager.css'><ul class='formManagerWrapper'>";
	return headerHTML;
	}

//Define our footer render pattern
pfh.renderFooter = function(ctx) {
	//Define any footer content here.
	var footerHTML = "</ul>";
	return footerHTML;
	}
	
//This function checks if Jquery is loaded, and append it to the page if it isn't.
pfh.CheckForJQuery = function () {
	if (typeof jQuery == 'undefined') {
		var JQ = document.createElement('script');
		JQ.type = 'text/javascript';
		JQ.onload = pfh.SetupJQuery;
		JQ.src = '//ajax.aspnetcdn.com/ajax/jQuery/jquery-2.1.3.min.js';
		document.body.appendChild(JQ);
	}
}

pfh.SetupJQuery = function() {
	jQuery.noConflict();
	_spBodyOnLoadFunctionNames.push("pfh.SetupBehaviours");
}

//Define our item Render pattern
//This will be called once for each item being rendered from the list.
//All fields in the view can be access using ctx.CurrentItem.InternalFieldName
//NB: The field must be included in the view for it to be available
pfh.CustomItem = function(ctx) {
	var cType = ctx.CurrentItem.ContentType;
	var tBehaviour = ctx.CurrentItem.TargetBehaviour;
	var formManagerItemID = "formManagerItem" + ctx.CurrentItem.ID
    var itemHTML = "<li class='formManagerItemWrapper' id='" + formManagerItemID + "'>";
   
    
    
    var actionItem = {
     "title":ctx.CurrentItem.Title,
     "actionURL": ctx.CurrentItem.EVOFormURL,
      "targetBehaviour": tBehaviour,
      "redirectURL": ctx.CurrentItem.EVOFormRedirectURL,
      }
	pfh.actionMatrix[formManagerItemID] = actionItem

    
	
	itemHTML += "<a href='" + ctx.CurrentItem.EVOFormURL + "' onClick='pfh.ItemClick(&quot;" + formManagerItemID + "&quot;);return false;'>";

    //Now change the background image based on the cType
    switch (cType)
    {
		case "EVO Form Entry - Nintex Form":
    	itemHTML += "<img style='top:30px; left:30px;position:absolute;' src='https://az158878.vo.msecnd.net/marketing/Partner_21474836635/Product_42949675001/Asset_fd119b84-aef1-48d6-80b9-802f74449a95/NFStoreEntryPoint96x96.png'></img>";
    
    	break;
    	
    	case "EVO Form Entry - External Form":
    	itemHTML += "<img style='top:30px; left:30px;position:absolute;' src='/_layouts/15/images/ltgen.png?rev=38'></img>";
    	
    	break;
    	
    	case "EVO Form Entry - Infopath Form":
    	itemHTML += "<img style='top:30px; left:30px;position:absolute;' src='/_layouts/15/images/ltdl.png?rev=38'></img>";
    	
    	break;
    	
    	case "EVO Form Entry - Word Form":
    	itemHTML += "<img style='top:30px; left:30px;width:90px;position:absolute;' src='/_layouts/15/images/256_ICDOTX.png?rev=38'></img>";
    	break;
    	
    	case "EVO Form Entry - Excel Survey":
    	itemHTML += "<img style='top:30px; left:30px;width:90px;position:absolute;' src='/_layouts/15/images/256_ICxlsX.png?rev=38'></img>";
    	break;
    	
	    default:
	    itemHTML += "<img style='left:-150px; top: -150px; position:absolute;' src='/_layouts/15/images/gettingstarted.png?rev=38'></img>";
	    
    }
    
    //Output the title block
    itemHTML += "<div class='formManagerItemTextWrapper' id='formManagerItemTextWrapper" + ctx.CurrentItem.ID + "'>";
    itemHTML += "<ul class='formManagerItemTextDetail'><li class='formManagerItemTextTitle'>" + ctx.CurrentItem.Title + "</li>";
    itemHTML += "<li class='formManagerItemTextDescription'>" + ctx.CurrentItem.EVOFormDescription + "</li>";
    itemHTML += "</ul></div>"
    
    //Finish link build
	itemHTML += "</a>";
    
	itemHTML += "</li>";
	
return itemHTML;	
}

pfh.ItemClick = function(itemID) {

var actionItem = pfh.actionMatrix[itemID];
pfh.ModalActionItem = null;

switch (actionItem.targetBehaviour)
	{
		case "New Window":
		
			window.open(actionItem.actionURL);
		
		break;
	
		case "Modal Dialog":
				pfh.ModalActionItem = itemID;
				var dialogOptions = {
					title: actionItem.title,
					url: actionItem.actionURL,
					dialogReturnValueCallback: pfh.ItemClickCallback
				};
				OpenPopUpPageWithDialogOptions(dialogOptions);
		break;
		
		default:
		
			window.location.href = actionItem.actionURL;
	}
}

pfh.ItemClickCallback = function(result, returnValue) {
	
	var actionItem = pfh.actionMatrix[pfh.ModalActionItem];
	if (result > 0)
	{
		if (actionItem.redirectURL)
		{
			window.location.href = actionItem.redirectURL;
		}
	}
	pfh.ModalActionItem = null;

}

//Define any code/function that needs to be run AFTER the page has been completed and the DOM is complete.
pfh.PostRenderCallback = function(ctx) {
}

//Define the function that will register our Override with SharePoint.
pfh.RegisterTemplateOverride = function () {
// 	Define a JavaScript object that will contain our Override
	var overrideCtx = {};
	overrideCtx.Templates = {};
	
//	Here we assign our Header and Footer functions to the template overrides.
	overrideCtx.Templates.Header = pfh.renderHeader;
	overrideCtx.Templates.Footer = pfh.renderFooter;

// 	And here we assign the CustomItem function to the Item registration.
	overrideCtx.Templates.Item = pfh.CustomItem;
	
//	And finally we add our PostRender function.
//  This expects a JavaScript array, so we pass the function in []
	overrideCtx.onPostRender = [pfh.PostRenderCallback(ctx)];
	
//	Register this Display Template against views with matching BaseViewID and ListTemplateType
//	See http://msdn.microsoft.com/en-us/library/microsoft.sharepoint.client.listtemplatetype(v=office.15).aspx for more ListTemplateTypes	
	overrideCtx.BaseViewID = 1;
	overrideCtx.ListTemplateType = 100;
	
//  Register the template overrides with SharePoint
	SPClientTemplates.TemplateManager.RegisterTemplateOverrides(overrideCtx);
};

//Register for MDS enabled site otherwise the display template doesn't work on refresh
//MNote: The ~sitecollection tokens cannot be used here so we use _spPageContextInfo.siteAbsoluteUrl instead
pfh.sitecolpath = window.location.pathname.substring(0,window.location.pathname.indexOf("/_layouts/15/start.aspx"))
RegisterModuleInit(pfh.sitecolpath + "/_catalogs/masterpage/Display%20Templates/csr_ovr_RenderFormManager.js", pfh.RegisterTemplateOverride); // CSR-override for MDS enabled site
pfh.RegisterTemplateOverride(); //CSR-override for MDS disabled site (because we need to call the entry point function in this case whereas it is not needed for anonymous functions)

